#include <Standalone.h>
#ifdef M68K
#include <PalmOS.h>
#else
#include <endianutils.h>
#include <palmos5.h>
#endif

#include "Clip_Res.h"

#define SWAP32( x ) ( ( ( x ) >> 24 ) | ( ( ( x ) & 0x00FF0000l ) >> 8 ) | ( ( ( x ) & 0x0000FF00l ) << 8 ) |  ( ( x ) << 24 ) )

#define RESID RESID_FldCut
STANDALONE_CODE_RESOURCE_TYPESTR_ID(SEGMENT_TYPE, RESID);

typedef void (*pfnFldCut)( const FieldType* fldP );

Boolean VerifyCopy( void* p, UInt16 size );

void MyFldCut( const FieldType* fldP )
{
    UInt16 start;
    UInt16 stop;
    UInt16    size;
    Char*     p;
    pfnFldCut oldTrap;

    FtrGet(MY_CRID, RESID, (UInt32*) &oldTrap );

    FldGetSelection( fldP, &start, &stop );

    if ( start == stop ) {
        SndPlaySystemSound( sndError );
        return;
    }

    size = stop - start;

    if ( size <= 1 ) {
        oldTrap( fldP );
        return;
    }

    p = FldGetTextPtr( fldP ) + start;

    ClipboardAddItem( clipboardText, p, stop - start );

    if ( ! VerifyCopy( p, stop - start ) ) {
        FrmAlert( ClipboardLimitAlert );
        return;
    }

    size = stop - start;

    FldDelete( (void*)fldP, start + 1, stop );
    FldSetSelection( (void*)fldP, start, start + 1 );
    FtrSet( MY_CRID, FTR_NO_TEXT_CLIPBOARD, 1 );
    oldTrap( fldP );
    FtrUnregister( MY_CRID, FTR_NO_TEXT_CLIPBOARD );
}



Boolean VerifyCopy( void* data, UInt16 size )
{
    MemHandle clipH;
    UInt16    clipSize;
    void*     clipData;
    Boolean   match;

    clipH = ClipboardGetItem( clipboardText, &clipSize );

    if ( clipH == NULL || clipSize != size )
        return false;

    clipData = MemHandleLock( clipH );

    match = ! MemCmp( clipData, data, size );

    MemHandleUnlock( clipH );

    return match;
}
